 MediaPortal/Incubator/Login/LoginModel.cs          |    2 +-
 .../Incubator/Trakt/Models/TraktSetupModel.cs      |  114 +-
 .../Incubator/Trakt/Service/TraktHandler.cs        |   25 +-
 MediaPortal/Incubator/Trakt/Trakt.csproj           |    2 +
 .../Settings/ReSharper/TeamMediaPortal.DotSettings |    6 +-
 .../Trakt/DataStructures/MovieScrobbleAndMode.cs   |   11 -
 .../Trakt/DataStructures/MovieSyncAndMode.cs       |   11 -
 .../Libraries/Trakt/DataStructures/TraktAccount.cs |   11 -
 .../Trakt/DataStructures/TraktActivity.cs          |   89 +-
 .../Trakt/DataStructures/TraktCalendar.cs          |   14 +-
 .../Libraries/Trakt/DataStructures/TraktEpisode.cs |   61 +-
 .../Trakt/DataStructures/TraktEpisodeSummary.cs    |   38 +-
 .../Trakt/DataStructures/TraktListItem.cs          |   30 +-
 .../Libraries/Trakt/DataStructures/TraktMovie.cs   |   69 +-
 .../Trakt/DataStructures/TraktMovieSummary.cs      |   48 +-
 .../Libraries/Trakt/DataStructures/TraktPerson.cs  |   13 +-
 .../Libraries/Trakt/DataStructures/TraktShow.cs    |  102 +-
 .../Trakt/DataStructures/TraktShowSeason.cs        |   39 -
 .../Trakt/DataStructures/TraktShowSummary.cs       |   75 +-
 .../Trakt/DataStructures/TraktSyncMovieResponse.cs |   35 +-
 .../Libraries/Trakt/DataStructures/TraktUser.cs    |   32 +-
 .../Trakt/DataStructures/TraktUserList.cs          |   47 +-
 .../Trakt/DataStructures/TraktUserListItem.cs      |  875 ++++---
 .../Trakt/Extension/DateTimeExtensions.cs          |   69 +
 .../Libraries/Trakt/Extension/JsonExtensions.cs    |   20 +-
 .../OnlineLibraries/Libraries/Trakt/TraktAPI.cs    | 2527 +++++++++++++-------
 .../OnlineLibraries/Libraries/Trakt/TraktLogger.cs |  245 +-
 .../Libraries/Trakt/TraktSettings.cs               |  234 +-
 .../OnlineLibraries/Libraries/Trakt/TraktURIs.cs   |  300 ++-
 .../OnlineLibraries/OnlineLibraries.csproj         |  109 +-
 30 files changed, 3183 insertions(+), 2070 deletions(-)

diff --git a/MediaPortal/Incubator/Trakt/Models/TraktSetupModel.cs b/MediaPortal/Incubator/Trakt/Models/TraktSetupModel.cs
index 6e67cd5..2880388 100644
--- a/MediaPortal/Incubator/Trakt/Models/TraktSetupModel.cs
+++ b/MediaPortal/Incubator/Trakt/Models/TraktSetupModel.cs
@@ -53,7 +53,7 @@ namespace MediaPortal.UiComponents.Trakt.Models
     public const string SERIES_BANNER_URL = "http://trakt.tv/user/{0}/widgets/watched/episode-thin-banner@2x.jpg";
     public const string MOVIES_BANNER_URL = "http://trakt.tv/user/{0}/widgets/watched/movie-thin-banner@2x.jpg";
 
-    public readonly static Guid TRAKT_SETUP_MODEL_ID = new Guid(TRAKT_SETUP_MODEL_ID_STR);
+    public static readonly Guid TRAKT_SETUP_MODEL_ID = new Guid(TRAKT_SETUP_MODEL_ID_STR);
 
     #endregion
 
@@ -221,23 +221,87 @@ namespace MediaPortal.UiComponents.Trakt.Models
           return false;
         }
         var movies = contentDirectory.Search(new MediaItemQuery(types, null, null), true);
-        TraktMovieSync syncData = new TraktMovieSync { UserName = Username, Password = Password, MovieList = new List<TraktMovieSync.Movie>() };
-        // First send all movies to Trakt that we have so they appear in library
-        foreach (var movie in movies)
-          syncData.MovieList.Add(ToMovie(movie));
-
-        TraktSyncModes traktSyncMode = TraktSyncModes.library;
-        var response = TraktAPI.SyncMovieLibrary(syncData, traktSyncMode);
-        ServiceRegistration.Get<ILogger>().Info("Trakt.tv: Movies '{0}': {1} inserted, {2} existing, {3} skipped movies.", traktSyncMode, response.Inserted, SafeCount(response.AlreadyExistMovies), SafeCount(response.SkippedMovies));
-
-        syncData.MovieList.Clear();
-        // Then send only the watched movies as "seen"
-        foreach (var movie in movies.Where(IsWatched))
-          syncData.MovieList.Add(ToMovie(movie));
-
-        traktSyncMode = TraktSyncModes.seen;
-        response = TraktAPI.SyncMovieLibrary(syncData, traktSyncMode);
-        ServiceRegistration.Get<ILogger>().Info("Trakt.tv: Movies '{0}': {1} inserted, {2} existing, {3} skipped movies.", traktSyncMode, response.Inserted, SafeCount(response.AlreadyExistMovies), SafeCount(response.SkippedMovies));
+
+        var syncCollectedMovies = movies.Select(movie => new TraktSyncMovieCollected
+        {
+          Ids = new TraktMovieId { Imdb = ToMovie(movie).Ids.Imdb, Tmdb = ToMovie(movie).Ids.Tmdb },
+          Title = ToMovie(movie).Title,
+          Year = ToMovie(movie).Year,
+          //TODO
+          //add "AudioChannels", "AudiCodec", etc...
+        }).ToList();
+
+        if (syncCollectedMovies.Count > 0)
+        {
+          //update cache
+          TraktCache.AddMoviesToCollection(syncCollectedMovies);
+          int pageSize = Extensions.OnlineLibraries.Libraries.Trakt.TraktSettings.SyncBatchSize;
+          int pages = (int)Math.Ceiling((double)syncCollectedMovies.Count / pageSize);
+          for (int i = 0; i < pages; i++)
+          {
+            var pagedMovies = syncCollectedMovies.Skip(i * pageSize).Take(pageSize).ToList();
+
+            // remove title/year such that match against online ID only
+            if (Extensions.OnlineLibraries.Libraries.Trakt.TraktSettings.SkipMoviesWithNoIdsOnSync)
+            {
+              pagedMovies.ForEach(m =>
+              {
+                m.Title = null;
+                m.Year = null;
+              });
+            }
+
+            var response = TraktAPI.AddMoviesToCollecton(new TraktSyncMoviesCollected { Movies = pagedMovies });
+
+            // remove movies from cache which didn't succeed
+            if (response != null && response.NotFound != null && response.NotFound.Movies.Count > 0)
+            {
+              TraktCache.RemoveMoviesFromCollection(response.NotFound.Movies);
+            }
+          }
+        }
+
+        // ServiceRegistration.Get<ILogger>().Info("Trakt.tv: Movies '{0}': {1} inserted, {2} existing, {3} skipped movies.", syncCollectedMovies, response.Inserted, SafeCount(response.AlreadyExistMovies), SafeCount(response.SkippedMovies));
+
+        var syncWatchedMovies = movies.Where(IsWatched).Select(movie => new TraktSyncMovieWatched
+        {
+          Ids = new TraktMovieId { Imdb = ToMovie(movie).Ids.Imdb, Tmdb = ToMovie(movie).Ids.Tmdb },
+          Title = ToMovie(movie).Title,
+          Year = ToMovie(movie).Year
+          // TODO
+          // add "watched add" 
+        }).ToList();
+
+        if (syncWatchedMovies.Count > 0)
+        {
+          // update internal cache
+          TraktCache.AddMoviesToWatchHistory(syncWatchedMovies);
+          int pageSize = Extensions.OnlineLibraries.Libraries.Trakt.TraktSettings.SyncBatchSize;
+          int pages = (int)Math.Ceiling((double)syncWatchedMovies.Count / pageSize);
+          for (int i = 0; i < pages; i++)
+          {
+            var pagedMovies = syncWatchedMovies.Skip(i * pageSize).Take(pageSize).ToList();
+            // remove title/year such that match against online ID only
+            if (Extensions.OnlineLibraries.Libraries.Trakt.TraktSettings.SkipMoviesWithNoIdsOnSync)
+            {
+              pagedMovies.ForEach(m =>
+              {
+                m.Title = null;
+                m.Year = null;
+              });
+            }
+
+            var response = TraktAPI.AddMoviesToWatchedHistory(new TraktSyncMoviesWatched { Movies = pagedMovies });
+
+            // remove movies from cache which didn't succeed
+            if (response != null && response.NotFound != null && response.NotFound.Movies.Count > 0)
+            {
+              TraktCache.RemoveMoviesFromWatchHistory(response.NotFound.Movies);
+            }
+          }
+        }
+
+        // ServiceRegistration.Get<ILogger>().Info("Trakt.tv: Movies '{0}': {1} inserted, {2} existing, {3} skipped movies.", traktSyncMode, response.Inserted, SafeCount(response.AlreadyExistMovies), SafeCount(response.SkippedMovies));
         return true;
       }
       catch (Exception ex)
@@ -358,24 +422,24 @@ namespace MediaPortal.UiComponents.Trakt.Models
       return list != null ? list.Count : 0;
     }
 
-    private TraktMovieSync.Movie ToMovie(MediaItem mediaItem)
+    private TraktMovie ToMovie(MediaItem mediaItem)
     {
       string value;
       int iValue;
-      DateTime dtValue;
+      int dtValue;
 
-      TraktMovieSync.Movie movie = new TraktMovieSync.Movie();
+      TraktMovie movie = new TraktMovie();
       if (MediaItemAspect.TryGetAttribute(mediaItem.Aspects, MovieAspect.ATTR_MOVIE_NAME, out value) && !string.IsNullOrWhiteSpace(value))
         movie.Title = value;
 
       if (MediaItemAspect.TryGetAttribute(mediaItem.Aspects, MovieAspect.ATTR_IMDB_ID, out value) && !string.IsNullOrWhiteSpace(value))
-        movie.IMDBID = value;
+        movie.Ids.Imdb = value;
 
       if (MediaItemAspect.TryGetAttribute(mediaItem.Aspects, MovieAspect.ATTR_TMDB_ID, out iValue) && iValue > 0)
-        movie.TMDBID = iValue.ToString();
+        movie.Ids.Tmdb = iValue;
 
       if (MediaItemAspect.TryGetAttribute(mediaItem.Aspects, MediaAspect.ATTR_RECORDINGTIME, out dtValue))
-        movie.Year = dtValue.Year.ToString();
+        movie.Year = dtValue;
 
       return movie;
     }
@@ -487,4 +551,4 @@ namespace MediaPortal.UiComponents.Trakt.Models
 
     #endregion
   }
-}
+}
\ No newline at end of file
diff --git a/MediaPortal/Incubator/Trakt/Service/TraktHandler.cs b/MediaPortal/Incubator/Trakt/Service/TraktHandler.cs
index 5878d34..81122d4 100644
--- a/MediaPortal/Incubator/Trakt/Service/TraktHandler.cs
+++ b/MediaPortal/Incubator/Trakt/Service/TraktHandler.cs
@@ -39,6 +39,7 @@ using MediaPortal.Extensions.OnlineLibraries.Libraries.Trakt.DataStructures;
 using MediaPortal.UI.Presentation.Players;
 using MediaPortal.UI.Presentation.Players.ResumeState;
 using MediaPortal.UI.Services.Players;
+using TraktSettings = MediaPortal.UiComponents.Trakt.Settings.TraktSettings;
 
 namespace MediaPortal.UiComponents.Trakt.Service
 {
@@ -57,7 +58,7 @@ namespace MediaPortal.UiComponents.Trakt.Service
 
     private AsynchronousMessageQueue _messageQueue;
     private readonly object _syncObj = new object();
-    private readonly SettingsChangeWatcher<Settings.TraktSettings> _settings = new SettingsChangeWatcher<Settings.TraktSettings>();
+    private readonly SettingsChangeWatcher<TraktSettings> _settings = new SettingsChangeWatcher<TraktSettings>();
     private readonly Dictionary<IPlayerSlotController, PositionWatcher> _progressUpdateWorks = new Dictionary<IPlayerSlotController, PositionWatcher>();
 
     public TraktHandler()
@@ -83,19 +84,19 @@ namespace MediaPortal.UiComponents.Trakt.Service
       }
     }
 
-    void SubscribeToMessages()
+    private void SubscribeToMessages()
     {
       if (_messageQueue != null)
         return;
       _messageQueue = new AsynchronousMessageQueue(this, new string[]
-        {
-           PlayerManagerMessaging.CHANNEL,
-        });
+      {
+        PlayerManagerMessaging.CHANNEL,
+      });
       _messageQueue.MessageReceived += OnMessageReceived;
       _messageQueue.Start();
     }
 
-    void UnsubscribeFromMessages()
+    private void UnsubscribeFromMessages()
     {
       if (_messageQueue == null)
         return;
@@ -103,7 +104,7 @@ namespace MediaPortal.UiComponents.Trakt.Service
       _messageQueue = null;
     }
 
-    void OnMessageReceived(AsynchronousMessageQueue queue, SystemMessage message)
+    private void OnMessageReceived(AsynchronousMessageQueue queue, SystemMessage message)
     {
       if (message.ChannelName == PlayerManagerMessaging.CHANNEL)
       {
@@ -160,7 +161,7 @@ namespace MediaPortal.UiComponents.Trakt.Service
 
           TraktMovieScrobble movie = scrobbleData as TraktMovieScrobble;
           if (movie != null)
-            TraktAPI.ScrobbleMovieState(movie, state);
+            TraktAPI.StartMovieScrobble(movie, state);
 
           TraktEpisodeScrobble episode = scrobbleData as TraktEpisodeScrobble;
           if (episode != null)
@@ -170,10 +171,10 @@ namespace MediaPortal.UiComponents.Trakt.Service
         if (removePsc)
           lock (_syncObj)
             _progressUpdateWorks.Remove(psc);
-
       }
       catch (ThreadAbortException)
-      { }
+      {
+      }
       catch (Exception ex)
       {
         ServiceRegistration.Get<ILogger>().Error("Trakt.tv: Exception while scrobbling", ex);
@@ -318,7 +319,7 @@ namespace MediaPortal.UiComponents.Trakt.Service
       if (!starting && progress < WATCHED_PERCENT)
         state = TraktScrobbleStates.cancelwatching;
 
-      scrobbleData.PluginVersion = TraktSettings.Version;
+      scrobbleData.PluginVersion = Extensions.OnlineLibraries.Libraries.Trakt.TraktSettings.Version;
       scrobbleData.MediaCenter = "MediaPortal 2";
       scrobbleData.MediaCenterVersion = Assembly.GetEntryAssembly().GetName().Version.ToString();
       scrobbleData.MediaCenterBuildDate = String.Empty;
@@ -333,4 +334,4 @@ namespace MediaPortal.UiComponents.Trakt.Service
       UnsubscribeFromMessages();
     }
   }
-}
+}
\ No newline at end of file
diff --git a/MediaPortal/Incubator/Trakt/Trakt.csproj b/MediaPortal/Incubator/Trakt/Trakt.csproj
index 24e8e9d..2083d00 100644
--- a/MediaPortal/Incubator/Trakt/Trakt.csproj
+++ b/MediaPortal/Incubator/Trakt/Trakt.csproj
@@ -33,6 +33,7 @@
   <ItemGroup>
     <Reference Include="System" />
     <Reference Include="System.Core" />
+    <Reference Include="System.Runtime.Serialization" />
     <Reference Include="System.Xml.Linq" />
     <Reference Include="System.Data.DataSetExtensions" />
     <Reference Include="Microsoft.CSharp" />
@@ -45,6 +46,7 @@
     </Compile>
     <Compile Include="Models\TraktSetupModel.cs" />
     <Compile Include="Properties\AssemblyInfo.cs" />
+    <Compile Include="Service\TraktBasicHandler.cs" />
     <Compile Include="Service\TraktHandler.cs" />
     <Compile Include="Settings\Configuration\TraktSettingConfiguration.cs" />
     <Compile Include="Settings\TraktSettings.cs" />
diff --git a/MediaPortal/Resources/Settings/ReSharper/TeamMediaPortal.DotSettings b/MediaPortal/Resources/Settings/ReSharper/TeamMediaPortal.DotSettings
index f6ada1c..596faa9 100644
--- a/MediaPortal/Resources/Settings/ReSharper/TeamMediaPortal.DotSettings
+++ b/MediaPortal/Resources/Settings/ReSharper/TeamMediaPortal.DotSettings
@@ -59,7 +59,7 @@
 	<s:Boolean x:Key="/Default/CodeStyle/CodeFormatting/CSharpFormat/INDENT_NESTED_FIXED_STMT/@EntryValue">False</s:Boolean>
 	<s:Boolean x:Key="/Default/CodeStyle/CodeFormatting/CSharpFormat/INDENT_NESTED_USINGS_STMT/@EntryValue">False</s:Boolean>
 	<s:String x:Key="/Default/CodeStyle/CodeFormatting/CSharpFormat/INITIALIZER_BRACES/@EntryValue">NEXT_LINE</s:String>
-	<s:String x:Key="/Default/CodeStyle/CodeFormatting/CSharpFormat/INVOCABLE_DECLARATION_BRACES/@EntryValue">NEXT_LINE</s:String>
+	
 	<s:Int64 x:Key="/Default/CodeStyle/CodeFormatting/CSharpFormat/KEEP_BLANK_LINES_IN_CODE/@EntryValue">2</s:Int64>
 	<s:Int64 x:Key="/Default/CodeStyle/CodeFormatting/CSharpFormat/KEEP_BLANK_LINES_IN_DECLARATIONS/@EntryValue">2</s:Int64>
 	<s:Boolean x:Key="/Default/CodeStyle/CodeFormatting/CSharpFormat/KEEP_USER_LINEBREAKS/@EntryValue">True</s:Boolean>
@@ -227,4 +227,6 @@
 	<s:String x:Key="/Default/CodeStyle/Naming/CSharpNaming/PredefinedNamingRules/=TypeParameters/@EntryIndexedValue">&lt;Policy Inspect="True" Prefix="T" Suffix="" Style="AaBb" /&gt;</s:String>
 	<s:String x:Key="/Default/CodeStyle/Naming/CSharpNaming/PredefinedNamingRules/=TypesAndNamespaces/@EntryIndexedValue">&lt;Policy Inspect="True" Prefix="" Suffix="" Style="AaBb" /&gt;</s:String>
 	<s:String x:Key="/Default/CodeStyle/Naming/CSharpNaming/UserRules/=f3b4c4c3_002D5ae8_002D47fd_002D8cde_002D9a05099b24cb/@EntryIndexedValue">&lt;Policy&gt;&lt;Descriptor Staticness="Instance" AccessRightKinds="Protected" Description=""&gt;&lt;ElementKinds&gt;&lt;Kind Name="FIELD" /&gt;&lt;Kind Name="READONLY_FIELD" /&gt;&lt;/ElementKinds&gt;&lt;/Descriptor&gt;&lt;Policy Inspect="True" Prefix="_" Suffix="" Style="aaBb" /&gt;&lt;/Policy&gt;</s:String>
-	<s:Boolean x:Key="/Default/Environment/SettingsMigration/IsMigratorApplied/=JetBrains_002EReSharper_002EPsi_002ECSharp_002ECodeStyle_002ESettingsUpgrade_002EMigrateBlankLinesAroundFieldToBlankLinesAroundProperty/@EntryIndexedValue">True</s:Boolean></wpf:ResourceDictionary>
\ No newline at end of file
+	<s:Boolean x:Key="/Default/Environment/SettingsMigration/IsMigratorApplied/=JetBrains_002EReSharper_002EPsi_002ECSharp_002ECodeStyle_002ESettingsUpgrade_002EAddAccessorOwnerDeclarationBracesMigration/@EntryIndexedValue">True</s:Boolean>
+	<s:Boolean x:Key="/Default/Environment/SettingsMigration/IsMigratorApplied/=JetBrains_002EReSharper_002EPsi_002ECSharp_002ECodeStyle_002ESettingsUpgrade_002EMigrateBlankLinesAroundFieldToBlankLinesAroundProperty/@EntryIndexedValue">True</s:Boolean>
+	<s:Boolean x:Key="/Default/Environment/SettingsMigration/IsMigratorApplied/=JetBrains_002EReSharper_002EPsi_002ECSharp_002ECodeStyle_002ESettingsUpgrade_002EMigrateThisQualifierSettings/@EntryIndexedValue">True</s:Boolean></wpf:ResourceDictionary>
\ No newline at end of file
diff --git a/MediaPortal/Source/Extensions/MetadataExtractors/OnlineLibraries/Libraries/Trakt/DataStructures/TraktActivity.cs b/MediaPortal/Source/Extensions/MetadataExtractors/OnlineLibraries/Libraries/Trakt/DataStructures/TraktActivity.cs
index 276eca8..c5bd877 100644
--- a/MediaPortal/Source/Extensions/MetadataExtractors/OnlineLibraries/Libraries/Trakt/DataStructures/TraktActivity.cs
+++ b/MediaPortal/Source/Extensions/MetadataExtractors/OnlineLibraries/Libraries/Trakt/DataStructures/TraktActivity.cs
@@ -27,27 +27,29 @@ namespace MediaPortal.Extensions.OnlineLibraries.Libraries.Trakt.DataStructures
     public class Activity : IEquatable<Activity>
     {
       #region IEquatable
+
       public bool Equals(Activity other)
       {
         if (other == null)
           return false;
 
-        return (Id == other.Id && Type == other.Type);
+        return (this.Id == other.Id && this.Type == other.Type);
       }
 
       public override int GetHashCode()
       {
-        return (Id + "-" + Type).GetHashCode();
+        return (this.Id.ToString() + "-" + this.Type).GetHashCode();
       }
+
       #endregion
 
       [DataMember(Name = "id")]
       public long Id { get; set; }
 
       [DataMember(Name = "timestamp")]
-      public long Timestamp { get; set; }
+      public string Timestamp { get; set; }
 
-      [DataMember(Name = "when")]
+      [DataMember(Name = "when", EmitDefaultValue = false)]
       public TraktWhen When { get; set; }
 
       [DataContract]
@@ -60,7 +62,7 @@ namespace MediaPortal.Extensions.OnlineLibraries.Libraries.Trakt.DataStructures
         public string Time { get; set; }
       }
 
-      [DataMember(Name = "elapsed")]
+      [DataMember(Name = "elapsed", EmitDefaultValue = false)]
       public TraktElapsed Elapsed { get; set; }
 
       [DataContract]
@@ -80,73 +82,40 @@ namespace MediaPortal.Extensions.OnlineLibraries.Libraries.Trakt.DataStructures
       public string Action { get; set; }
 
       [DataMember(Name = "user")]
-      public TraktUser User { get; set; }
-
-      [DataMember(Name = "rating")]
-      public string Rating { get; set; }
+      public TraktUserSummary User { get; set; }
 
-      [DataMember(Name = "rating_advanced")]
-      public string RatingAdvanced { get; set; }
+      [DataMember(Name = "rating", EmitDefaultValue = false)]
+      public int Rating { get; set; }
 
-      [DataMember(Name = "use_rating_advanced")]
-      public bool UseRatingAdvanced { get; set; }
+      [DataMember(Name = "progress", EmitDefaultValue = false)]
+      public float Progress { get; set; }
 
-      [DataMember(Name = "episode")]
-      public TraktEpisode Episode { get; set; }
+      [DataMember(Name = "episode", EmitDefaultValue = false)]
+      public TraktEpisodeSummary Episode { get; set; }
 
-      [DataMember(Name = "episodes")]
-      public List<TraktEpisode> Episodes { get; set; }
+      [DataMember(Name = "episodes", EmitDefaultValue = false)]
+      public List<TraktEpisodeSummary> Episodes { get; set; }
 
-      [DataMember(Name = "show")]
-      public TraktShow Show { get; set; }
+      [DataMember(Name = "show", EmitDefaultValue = false)]
+      public TraktShowSummary Show { get; set; }
 
-      [DataMember(Name = "movie")]
-      public TraktMovie Movie { get; set; }
+      [DataMember(Name = "season", EmitDefaultValue = false)]
+      public TraktSeasonSummary Season { get; set; }
 
-      [DataMember(Name = "review")]
-      public Activity.TraktShout Review { get; set; }
+      [DataMember(Name = "movie", EmitDefaultValue = false)]
+      public TraktMovieSummary Movie { get; set; }
 
-      [DataMember(Name = "shout")]
-      public TraktShout Shout { get; set; }
+      [DataMember(Name = "shout", EmitDefaultValue = false)]
+      public TraktComment Shout { get; set; }
 
-      [DataContract]
-      public class TraktShout
-      {
-        [DataMember(Name = "id")]
-        public long Id { get; set; }
-
-        [DataMember(Name = "text")]
-        public string Text { get; set; }
-
-        [DataMember(Name = "text_html")]
-        public string TextHTML { get; set; }
-
-        [DataMember(Name = "spoiler")]
-        public bool Spoiler { get; set; }
-      }
+      [DataMember(Name = "list", EmitDefaultValue = false)]
+      public TraktListDetail List { get; set; }
 
-      [DataMember(Name = "list")]
-      public TraktList List { get; set; }
-
-      [DataMember(Name = "list_item")]
+      [DataMember(Name = "list_item", EmitDefaultValue = false)]
       public TraktListItem ListItem { get; set; }
 
-      [DataContract]
-      public class TraktListItem
-      {
-        [DataMember(Name = "type")]
-        public string Type { get; set; }
-
-        [DataMember(Name = "show")]
-        public TraktShow Show { get; set; }
-
-        [DataMember(Name = "movie")]
-        public TraktMovie Movie { get; set; }
-
-        [DataMember(Name = "episode")]
-        public TraktEpisode Episode { get; set; }
-      }
+      [DataMember(Name = "person", EmitDefaultValue = false)]
+      public TraktPersonSummary Person { get; set; }
     }
-
   }
 }
diff --git a/MediaPortal/Source/Extensions/MetadataExtractors/OnlineLibraries/Libraries/Trakt/DataStructures/TraktCalendar.cs b/MediaPortal/Source/Extensions/MetadataExtractors/OnlineLibraries/Libraries/Trakt/DataStructures/TraktCalendar.cs
index e0cb518..3174d17 100644
--- a/MediaPortal/Source/Extensions/MetadataExtractors/OnlineLibraries/Libraries/Trakt/DataStructures/TraktCalendar.cs
+++ b/MediaPortal/Source/Extensions/MetadataExtractors/OnlineLibraries/Libraries/Trakt/DataStructures/TraktCalendar.cs
@@ -1,15 +1,11 @@
-﻿using System.Collections.Generic;
-using System.Runtime.Serialization;
+﻿using System.Runtime.Serialization;
 
 namespace MediaPortal.Extensions.OnlineLibraries.Libraries.Trakt.DataStructures
 {
   [DataContract]
-  public class TraktCalendar : TraktResponse
+  public class TraktCalendar : TraktEpisodeSummaryEx
   {
-    [DataMember(Name = "date")]
-    public string Date { get; set; }
-
-    [DataMember(Name = "episodes")]
-    public List<TraktEpisodeSummary> Episodes { get; set; }
+    [DataMember(Name = "airs_at")]
+    public string AirsAt { get; set; }
   }
-}
+}
\ No newline at end of file
diff --git a/MediaPortal/Source/Extensions/MetadataExtractors/OnlineLibraries/Libraries/Trakt/DataStructures/TraktEpisode.cs b/MediaPortal/Source/Extensions/MetadataExtractors/OnlineLibraries/Libraries/Trakt/DataStructures/TraktEpisode.cs
index cdb617d..7b20b15 100644
--- a/MediaPortal/Source/Extensions/MetadataExtractors/OnlineLibraries/Libraries/Trakt/DataStructures/TraktEpisode.cs
+++ b/MediaPortal/Source/Extensions/MetadataExtractors/OnlineLibraries/Libraries/Trakt/DataStructures/TraktEpisode.cs
@@ -14,62 +14,7 @@ namespace MediaPortal.Extensions.OnlineLibraries.Libraries.Trakt.DataStructures
     [DataMember(Name = "title")]
     public string Title { get; set; }
 
-    [DataMember(Name = "tvdb_id")]
-    public int TVDbID { get; set; }
-
-    [DataMember(Name = "imdb_id")]
-    public string IMDbID { get; set; }
-
-    [DataMember(Name = "overview")]
-    public string Overview { get; set; }
-
-    [DataMember(Name = "url")]
-    public string Url { get; set; }
-
-    [DataMember(Name = "first_aired")]
-    public long FirstAired { get; set; }
-
-    [DataMember(Name = "first_aired_utc")]
-    public long FirstAiredUtc { get; set; }
-
-    [DataMember(Name = "first_aired_iso")]
-    public string FirstAiredIso { get; set; }
-
-    [DataMember(Name = "first_aired_localized")]
-    public long FirstAiredLocalized { get; set; }
-
-    [DataMember(Name = "runtime")]
-    public int Runtime { get; set; }
-
-    [DataMember(Name = "in_watchlist")]
-    public bool InWatchList { get; set; }
-
-    [DataMember(Name = "in_collection")]
-    public bool InCollection { get; set; }
-
-    [DataMember(Name = "watched")]
-    public bool Watched { get; set; }
-
-    [DataMember(Name = "plays")]
-    public int Plays { get; set; }
-
-    [DataMember(Name = "rating")]
-    public string Rating { get; set; }
-
-    [DataMember(Name = "rating_advanced")]
-    public int RatingAdvanced { get; set; }
-
-    [DataMember(Name = "ratings")]
-    public TraktRatings Ratings { get; set; }
-
-    [DataMember(Name = "images")]
-    public ShowImages Images { get; set; }
-
-    [DataContract]
-    public class ShowImages
-    {
-      [DataMember(Name = "screen")]
-      public string Screen { get; set; }
-    }
+    [DataMember(Name = "ids")]
+    public TraktEpisodeId Ids { get; set; }
   }
-}
+}
\ No newline at end of file
diff --git a/MediaPortal/Source/Extensions/MetadataExtractors/OnlineLibraries/Libraries/Trakt/DataStructures/TraktEpisodeSummary.cs b/MediaPortal/Source/Extensions/MetadataExtractors/OnlineLibraries/Libraries/Trakt/DataStructures/TraktEpisodeSummary.cs
index 55b3518..1d7899a 100644
--- a/MediaPortal/Source/Extensions/MetadataExtractors/OnlineLibraries/Libraries/Trakt/DataStructures/TraktEpisodeSummary.cs
+++ b/MediaPortal/Source/Extensions/MetadataExtractors/OnlineLibraries/Libraries/Trakt/DataStructures/TraktEpisodeSummary.cs
@@ -1,19 +1,33 @@
-﻿using System.Runtime.Serialization;
+﻿using System.Collections.Generic;
+using System.Runtime.Serialization;
 
 namespace MediaPortal.Extensions.OnlineLibraries.Libraries.Trakt.DataStructures
 {
-  [DataContract]
-  public class TraktEpisodeSummary
-  {
-    [DataMember(Name = "show")]
-    public TraktShow Show { get; set; }
+    [DataContract]
+    public class TraktEpisodeSummary : TraktEpisode
+    {
+        [DataMember(Name = "images")]
+        public TraktEpisodeImages Images { get; set; }
 
-    [DataMember(Name = "episode")]
-    public TraktEpisode Episode { get; set; }
+        [DataMember(Name = "number_abs")]
+        public int? AbsoluteNumber { get; set; }
 
-    public override string ToString()
-    {
-      return string.Format("{0} - {1}x{2}{3}", Show.Title, Episode.Season, Episode.Number, string.IsNullOrEmpty(Episode.Title) ? string.Empty : " - " + Episode.Title);
+        [DataMember(Name = "first_aired")]
+        public string FirstAired { get; set; }
+
+        [DataMember(Name = "updated_at")]
+        public string UpdatedAt { get; set; }
+
+        [DataMember(Name = "overview")]
+        public string Overview { get; set; }
+
+        [DataMember(Name = "rating")]
+        public double? Rating { get; set; }
+
+        [DataMember(Name = "votes")]
+        public int Votes { get; set; }
+
+        [DataMember(Name = "available_translations")]
+        public List<string> AvailableTranslations { get; set; }
     }
-  }
 }
diff --git a/MediaPortal/Source/Extensions/MetadataExtractors/OnlineLibraries/Libraries/Trakt/DataStructures/TraktListItem.cs b/MediaPortal/Source/Extensions/MetadataExtractors/OnlineLibraries/Libraries/Trakt/DataStructures/TraktListItem.cs
index b378de9..63f62b4 100644
--- a/MediaPortal/Source/Extensions/MetadataExtractors/OnlineLibraries/Libraries/Trakt/DataStructures/TraktListItem.cs
+++ b/MediaPortal/Source/Extensions/MetadataExtractors/OnlineLibraries/Libraries/Trakt/DataStructures/TraktListItem.cs
@@ -5,29 +5,25 @@ namespace MediaPortal.Extensions.OnlineLibraries.Libraries.Trakt.DataStructures
   [DataContract]
   public class TraktListItem
   {
+    [DataMember(Name = "listed_at")]
+    public string ListedAt { get; set; }
+
     [DataMember(Name = "type")]
     public string Type { get; set; }
 
-    [DataMember(Name = "title")]
-    public string Title { get; set; }
-
-    #region Movies
-    [DataMember(Name = "imdb_id")]
-    public string ImdbId { get; set; }
+    [DataMember(Name = "movie")]
+    public TraktMovieSummary Movie { get; set; }
 
-    [DataMember(Name = "year")]
-    public int Year { get; set; }
-    #endregion
-
-    #region Shows/Episodes
-    [DataMember(Name = "tvdb_id")]
-    public string TvdbId { get; set; }
+    [DataMember(Name = "show")]
+    public TraktShowSummary Show { get; set; }
 
     [DataMember(Name = "season")]
-    public int Season { get; set; }
+    public TraktSeasonSummary Season { get; set; }
 
     [DataMember(Name = "episode")]
-    public int Episode { get; set; }
-    #endregion
+    public TraktEpisodeSummary Episode { get; set; }
+
+    [DataMember(Name = "person")]
+    public TraktPersonSummary Person { get; set; }
   }
-}
+}
\ No newline at end of file
